.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include try_color_izer.inc

.data
	brush    dd 0
	stat_win dd 0
	
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL color:DWORD
	LOCAL buf[16]:BYTE
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke GetDlgItem, hWin, 1002
		mov    stat_win, eax
		invoke CreateSolidBrush, 0ffffffh
		mov    brush, eax
		
	.elseif eax==WM_COMMAND
		.if wParam == 1001
			invoke Color_izer, hWin, 0ff0000h ;80000001h
			mov    color, eax
			.if eax != -1            ; CHECK IF "CANCEL" or "X" WAS PRESSED
				.if eax > 0ffffffh   ; CHECK IF SELECTED COLOR IS SYSTEM COLOR
					invoke DeleteObject, brush
					mov    eax, color
					and    eax, 0ffh
					invoke GetSysColor, eax
					invoke CreateSolidBrush, eax
					mov    brush, eax
				.else
					invoke DeleteObject, brush
					invoke CreateSolidBrush, color
					mov    brush, eax
				.endif
				invoke InvalidateRect,  hWin, 0, 0
			.endif
		.endif
	.elseif eax==WM_CTLCOLORSTATIC
		mov    eax, lParam
		.if eax == stat_win 
			mov    eax, brush ; WE'RE PAINTING OUR WINDOW HERE 
			ret
		.endif
		mov    eax, FALSE
		ret
	.elseif eax==WM_CLOSE
		invoke DeleteObject, brush
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
